//*******************************************************
//@@ohbPUePWQR V\vO
//     PIC16F1823 7seg Display Program
//  file name: main.c
//@@@ʐMŎ󂯂̎wԖڐVZOkdcɕ\
//        recieve number display to 7seg. Display 
//@@@PA0:ICSPDAT/TXD/SET Switch
//@@@PA1:ICSPCLK/RXD
//@@@PA2:LED
//@@@PA3:Reset
//@@@PA4:7seg.-g     1=Lighting
//@@@PA5:7seg.-dp    1=Lighting
//@@@PC0:7seg.-a     1=Lighting
//@@@PC1:7seg.-b     1=Lighting
//@@@PC2:7seg.-c     1=Lighting
//@@@PC3:7seg.-d     1=Lighting
//@@@PC4:7seg.-e     1=Lighting
//@@@PC5:7seg.-f     1=Lighting
//
//		ZbgɂkdcƂ_łĂ鎞
//		@ZbgXCb`nmĂƎwԍ̐ݒ胂[hɂȂB
//		E߂Ɏwԍ̐ݒ
//		@݂̎wԍATbԊuœ_łȂ
//		@O`X̐JԂ\Bwԍݒ肵
//		@̐\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdcƂ_̂
//		@XCb`𗣂Ɛݒ肳B
//		EʐM̐ݒ
//		@݂̎w蕶ATbԊuœ_łȂ
//		@f`fAffAfbfAffAf`fDDDD̏ɕJԂ\B
//		@wԍݒ肵́@̐\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdcƂ_̂
//		@XCb`𗣂Ɛݒ肳B
//
//
// wԍ̐
// ASCII	O P Q R S T U V W X cr ƑMꂽ
// @@@@ b b b b b b b b b b
// @@@@ b b b b b b b b b { 0 ̎wԍŕ\
//          b b b b b b b b {||1 ̎wԍŕ\
//          b b b b b b b {||| 2 ̎wԍŕ\
//          b b b b b b {|||||3 ̎wԍŕ\
//          b b b b b {|||||| 4 ̎wԍŕ\
//          b b b b {||||||||5 ̎wԍŕ\
//          b b b {||||||||| 6 ̎wԍŕ\
//          b b {|||||||||||7 ̎wԍŕ\
//          b {|||||||||||| 8 ̎wԍŕ\
//          {||||||||||||||9 ̎wԍŕ\
//
//
// w蕶̐iʐMaorj
//		@'A':1200BPS
//		@'b':2400BPS
//		@'C':4800BPS
//		@'d':9600BPS
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2015/01/10  New(TAB4)  Taishi
//*******************************************************

#include	<htc.h>

//#define	_XTAL_FREQ	32000000L	//	giWlgS{j
#define	_XTAL_FREQ	8000000L	//	giWlgj

// CONFIG for 16F1823

__CONFIG (	FCMEN_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	IESO_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	CLKOUTEN_OFF		//	1(OFF) = CLKOUT@\𖳌ɂBCLKOUT sI/O Ƃċ@\
		&	BOREN_ON			//	11 = BOR(uEAEgZbg)Lɂ
		&	CPD_OFF				//	1(OFF) = f[^̃R[hی𖳌ɂ
		&	CP_OFF				//	1(OFF) = vÕR[hی𖳌ɂ
		&	MCLRE_ON			//	0(OFF) = MCLR/VPP s̓fW^͂Ƃċ@\B
		&	PWRTE_ON			//	0 = PWRT(p[Abv^C}[)Lɂ
		&	WDTE_OFF			//	00 = WDT(EHb`hbO^C}[)𖳌ɂ
		&	FOSC_INTOSC			//	100 = INTOSCIV[^:CLKIN sI/O Ƃċ@\
);

								//	fobO@\͏ݑuɔCij

//__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
//		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
//		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
//		&	PLLEN_ON			//	1 = 4xPLL Lɂ
//		&	WRT_OFF				//	11 = ݕیOFF ɂ
//);

__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
		&	PLLEN_OFF			//	1 = 4xPLL 𖳌ɂ
		&	WRT_OFF				//	11 = ݕیOFF ɂ
);

const unsigned char	hex_to_7seg[16]={
		// D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
		0b00111111,				// 0
		0b00000110,				// 1
		0b01011011,				// 2
		0b01001111,				// 3
		0b01100110,				// 4
		0b01101101,				// 5
		0b01111101,				// 6
		0b00000111,				// 7
		0b01111111,				// 8
		0b01101111,				// 9
		0b01110111,				// A
		0b01111100,				// B
		0b01011000,				// C
		0b01011110,				// D
		0b01111001,				// E
		0b01110001,				// F
};
		// D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
const unsigned char	seg7_minus = 0b01000000;		// -
const unsigned char	seg7_dot   = 0b10000000;		// .

// ----- UART ֌W ------
#define	FOSC				_XTAL_FREQ

#define	BIT_RATE1200		1200								// rbg|g:1200
#define	BIT_RATE2400		2400								// rbg|g:2400
#define	BIT_RATE4800		4800								// rbg|g:4800
#define	BIT_RATE9600		9600								// rbg|g:9600

// dt`qs̐ݒl

// aor
#define	BPS_1200		(unsigned char)(((long)FOSC/(long)64/(long)BIT_RATE1200) - 1)	// taqqO̒l(1200)
#define	BPS_2400		(unsigned char)(((long)FOSC/(long)64/(long)BIT_RATE2400) - 1)	// taqqO̒l(2400)
#define	BPS_4800		(unsigned char)(((long)FOSC/(long)64/(long)BIT_RATE4800) - 1)	// taqqO̒l(4800)
#define	BPS_9600		(unsigned char)(((long)FOSC/(long)64/(long)BIT_RATE9600) - 1)	// taqqO̒l(9600)
// -----------------------

// ------ TIMER0 ֘A -----
//#define	TMR0_COUNT	(250)				// ^C}[OŃJEgl
#define	TMR0_COUNT	(62)				// ^C}[OŃJEgl
#define	TMR0_DATA	(256-TMR0_COUNT)	// ^C}[ÕJEgJnl
// ------------------------

unsigned char	out_7seg_data=0;		// PUiVZOf[^ɕϊA
unsigned short	wait_ms_count_a=0;		// 荞݂łPrŃ_EJEgl
unsigned short	wait_ms_count_b=0;		// 荞݂łPrŃ_EJEgl
unsigned short	wait_ms_count_led=0;	// kdc_銄荞݂łPrŃ_EJEgl

#define	NUM_ADR		1					// ddoqnlAhXiԖڂ̕\邩̔ԍj
unsigned char	target_number=0;		// Ԗڂ̕\邩̔ԍ(0--9)

#define	CHR_BPS		2					// ddoqnlAhXiʐMaorw肷镶j
unsigned char	bps_character=0x0d;		// ʐMaorw肷镶(0x0a:1200, 0x0b:2400, 0x0c:4800, 0x0d:9600)


unsigned char	recieved_data[12];		// VAŎ󂯂f[^

//***************************
// Timer0 ݒ
//***************************
static	
void	timer0_init(void)
{
	OPTION_REG = 0b00000100;				// vXP[g@1/32A(32/4)MHzȂ̂250kHzNbN^C}[Oɓ
	TMR0 = TMR0_DATA;						// JE^[ݒ
	TMR0IF = 0;								// ^C}[OI[o[t[tONA
}

//***************************
// INT* 
// Timer0 ݂݂̂ɑΉ
//***************************
void	interrupt isr(void)
{
	static	unsigned char	count=0;

	if(TMR0IF == 1){							// ^C}[OI[o[t[݂L
		TMR0 = TMR0_DATA;						// JE^[Đݒ
// ------ ̊Ԃɏ[] -----
		switch(count){
		 case 0:								// seg-a
			RA5 = 0;							// Ԃ炱̑O͕KȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x01) == 0){	// 7seg -a
				RC0 = 0;
			}else{
				RC0 = 1;
			}
			break;
		 case 1:								// seg-b
			RC0 = 0;							// Ԃ炱̑O͕Kseg-aȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x02) == 0){	// 7seg -b
				RC1 = 0;
			}else{
				RC1 = 1;
			}
			break;
		 case 2:								// seg-c
			RC1 = 0;							// Ԃ炱̑O͕Kseg-bȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x04) == 0){	// 7seg -c
				RC2 = 0;
			}else{
				RC2 = 1;
			}
			break;
		 case 3:								// seg-d
			RC2 = 0;							// Ԃ炱̑O͕Kseg-cȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x08) == 0){	// 7seg -d
				RC3 = 0;
			}else{
				RC3 = 1;
			}
			break;
		 case 4:								// seg-e
			RC3 = 0;							// Ԃ炱̑O͕Kseg-dȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x10) == 0){	// 7seg -e
				RC4 = 0;
			}else{
				RC4 = 1;
			}
			break;
		 case 5:								// seg-f
			RC4 = 0;							// Ԃ炱̑O͕Kseg-eȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x20) == 0){	// 7seg -f
				RC5 = 0;
			}else{
				RC5 = 1;
			}
			break;
		 case 6:								// seg-g
			RC5 = 0;							// Ԃ炱̑O͕Kseg-fȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x40) == 0){	// 7seg -g
				RA4 = 0;
			}else{
				RA4 = 1;
			}
			break;
		 case 7:								// dp
			RA4 = 0;							// Ԃ炱̑O͕Kseg-gȂ̂ł̃ZOgnee
			if((out_7seg_data & 0x80) == 0){	// dp
				RA5 = 0;
			}else{
				RA5 = 1;
			}
			break;
		}
		count++;
		count &= 0x07;

		if(wait_ms_count_a != 0){
			wait_ms_count_a--;
		}
		if(wait_ms_count_b != 0){
			wait_ms_count_b--;
		}
		if(wait_ms_count_led != 0){
			wait_ms_count_led--;
		}

// ------ ̊Ԃɏ[܂] ------
		TMR0IF = 0;							// ^C}[OI[o[t[tONA
	}
}

//***************************
// UART ݒ
// RXD:RA1
// TXD:RA0
//***************************
void	uart_init(void)
{
	RXDTSEL = 1;				// RXD=RA1 only 16F1823
	TXCKSEL = 1;				// TXD=RA0 only 16F1823

	SPBRGH = 0;					// PQOO`XUOO̊Ԃ̓{[Cgݒ背WX^̏ʂWrbg͏ɂO
	if(bps_character == 0x0a){
		SPBRGL = BPS_1200;
	}else if(bps_character == 0x0b){
		SPBRGL = BPS_2400;
	}else if(bps_character == 0x0c){
		SPBRGL = BPS_4800;
	}else{
		SPBRGL = BPS_9600;
	}

	__delay_ms(1);				//	Pҋ@;
	TXEN = 1;					// ML
	SYNC = 0;					// 񓯊ʐMij
	CREN = 1;					// ML
	SPEN = 1;					// VA|[gL
	__delay_ms(1);				//	Pҋ@;

}
//***************************
// UART TxD One Char
//  荞݂gȂ
//***************************
void	uart_tx_one(unsigned char uc)
{
	while(TXIF == 0){
		;
	}
	TXREG = uc;
}
//***************************
// UART RXD Read
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//         : 0xff=t[~OG[
//         : 0xfe=I[o[G[
//  荞݂gȂ
//***************************
unsigned char	uart_rx_one(unsigned char *uc)
{
	unsigned char	r=0;
	unsigned char	uart_err;			// G[

	if(RCIF == 0){						// Mf[^
		;
	}else{
		uart_err = RCSTA;				// G[Ԃ擾
		*uc = RCREG;					// Mf[^擾
		uart_err &= 0b00000110;			// G[rbg𒊏o
		if(uart_err == 0){				// G[̎
			r = 1;
		}else if((uart_err & 0b00000100)!=0){	// t[~OG[
			r = 0xff;					// f[^͎̂Ă
		}else{
			CREN = 0;					// M
			__delay_ms(1);				//	Pҋ@;
			CREN = 1;					// ML
			r = 0xfe;					// f[^͎̂Ă
		}
		wait_ms_count_led = 50;
	}
	return(r);
}

// *****************************
// ASCII --> 7seg Data
//   uc: ASCii Data
// ߂l  : VZOf[^
//   A}CiXAhbgȊO͂OiȂj߂
// *****************************
static
unsigned char	chg_7seg_data(unsigned char uc)
{
	unsigned char	r=0;

	if(uc == '-'){							// }CiX
		r = seg7_minus;						// -
	}else if(uc == '.'){					// hbg
		r = seg7_dot;						// .
	}else if(('0' <= uc)&&(uc <= '9')){		// 
		r = hex_to_7seg[uc & 0x0f];			// PUiVZOf[^ɕϊ
	}

	return(r);
}

// *****************************
// EEPROM Read/Write
//  : adr=ddoqnl̃AhX(0--255)
//        dat=ddoqnlɏf[^̃|C^A͓ǂݏof[^|C^
//        wr = 1:Write, 0:Read
//  ̊֐ĂԎɂ͊݋֎~̕KvL
// *****************************
void	eep_read_write(unsigned char adr, unsigned char *dt, unsigned char wr)
{
	if(wr == 1){					// at Write
		EEADR = adr;
		EEDAT = *dt;
		WREN  = 1;
		EECON2 = 0x55;
		EECON2 = 0xaa;
		WR = 1;
		while(EEIF == 0){			// Wait Write End
			NOP();
		}
		EEIF = 0;
		WREN = 0;
	}else{							// at Read
		EEADR = adr;
		EEPGD = 0;
		CFGS = 0;
		RD = 1;
		*dt = EEDAT;
	}
}
// *****************************
// \ʒu̐ݒ菈
// *****************************
void	setpro_pos(void)
{
	unsigned char	n;
	unsigned char	j;
	unsigned char	blink=0;

	wait_ms_count_a = 500;
	wait_ms_count_b = 5000;
	n = target_number;
	out_7seg_data = hex_to_7seg[n & 0x0f];				// PUiVZOf[^ɕϊ

	while(1){
		if(wait_ms_count_a == 0){
			wait_ms_count_a = 500;
			blink ^= 1;
			if(blink == 0){
				out_7seg_data = 0;
			}else{
				out_7seg_data = hex_to_7seg[n & 0x0f];			// PUiVZOf[^ɕϊ
			}
		}

		if(wait_ms_count_b == 0){
			wait_ms_count_b = 5000;
			//@VZO\l̐is
			n++;												//  ̐l
			if(10 <= n){
				n = 0;
			}
			out_7seg_data = hex_to_7seg[n & 0x0f];				// PUiVZOf[^ɕϊ
			wait_ms_count_a = 500;
			blink = 1;
		}

		if(RA0 == 0){
			out_7seg_data = hex_to_7seg[n & 0x0f];				// PUiVZOf[^ɕϊ
			__delay_ms(1000);									//	Pbҋ@;
			if(RA0 == 0){										// SET SW:ON Pbԉ
				RA2 = 1;										// LED ON
				out_7seg_data |= 0x80;							// dp ON
				while(1){										// XCb`܂ő҂
					if(RA0 == 1){
						__delay_ms(50);							//	TOҋ@;
						if(RA0 == 1){							// SET SW:OFF
							break;		// ݒ菈
						}
					}
				}
				if(target_number != n){							// ύX
					target_number = n;								// ԍ
					di();											//	荞݋֎~
					eep_read_write(NUM_ADR, &target_number, 1);		// EEPROM Write
					GIE = 1;										// SĂ̊݉
				}
				RA2 = 0;
				out_7seg_data &= ~0x80;							// dp OFF
				break;
			}
		}
	}
}

// *****************************
// ʐMaor̐ݒ菈
// *****************************
void	setpro_bps(void)
{
	unsigned char	n;
	unsigned char	j;
	unsigned char	blink=0;

	wait_ms_count_a = 500;
	wait_ms_count_b = 5000;
	n = bps_character;
	out_7seg_data = hex_to_7seg[n & 0x0f];				// PUiVZOf[^ɕϊ

	while(1){
		if(wait_ms_count_a == 0){
			wait_ms_count_a = 500;
			blink ^= 1;
			if(blink == 0){
				out_7seg_data = 0;
			}else{
				out_7seg_data = hex_to_7seg[n & 0x0f];			// PUiVZOf[^ɕϊ
			}
		}

		if(wait_ms_count_b == 0){
			wait_ms_count_b = 5000;
			//@l̐is
			n++;												//  ̕
			if(0x0d < n){
				n = 0x0a;
			}
			out_7seg_data = hex_to_7seg[n & 0x0f];				// PUiVZOf[^ɕϊ
			wait_ms_count_a = 500;
			blink = 1;
		}

		if(RA0 == 0){
			out_7seg_data = hex_to_7seg[n & 0x0f];				// PUiVZOf[^ɕϊ
			__delay_ms(1000);									//	Pbҋ@;
			if(RA0 == 0){										// SET SW:ON Pbԉ
				RA2 = 1;										// LED ON
				out_7seg_data |= 0x80;							// dp ON
				while(1){										// XCb`܂ő҂
					if(RA0 == 1){
						__delay_ms(50);							//	TOҋ@;
						if(RA0 == 1){							// SET SW:OFF
							break;		// ݒ菈
						}
					}
				}
				if(bps_character != n){							// ύX
					bps_character = n;							// 
					di();										//	荞݋֎~
					eep_read_write(CHR_BPS, &bps_character, 1);	// EEPROM Write
					GIE = 1;									// SĂ̊݉
				}
				RA2 = 0;
				out_7seg_data &= ~0x80;							// dp OFF
				break;
			}
		}
	}
}
// *****************************
// ݒ菈
// *****************************
void	setpro(void)
{
	unsigned char	n;
	unsigned char	j;
	unsigned char	blink=0;

	RA5 = 1;
	RA2 = 1;
	while(1){					// XCb`܂ő҂
		if(RA0 == 1){
			__delay_ms(50);		//	TOҋ@;
			if(RA0 == 1){		// SET SW:OFF
				break;			// ݒ菈֔
			}
		}
	}
	RA5 = 0;
	RA2 = 0;

	out_7seg_data = 0;						// PUiVZOf[^ɕϊ
	timer0_init();							// Timer0 ݒ
	TMR0IE = 1;								// slqO̊݉
	GIE = 1;								// SĂ̊݉

	while(1){
		setpro_pos();						// \ʒu̐ݒ菈
		setpro_bps();						// ʐMaor̐ݒ菈
	}
}
// *****************************
//	main
//
//  2015/01/10 New   Taishi
// *****************************
void	main(void)
{
	unsigned char	i;
	unsigned char	j;
	unsigned char	h;				// IMf[^
	unsigned char	uc;				// Mf[^

	di();							//	荞݋֎~

//				    76543210
	OSCCON	    = 0b01110000;		//	NbNWlg@c@okkHLȂ̂ŎRQlg

	OPTION_REG &= 0b01111111;		// Ŝ̃vAbvLɂ

//				    76543210		//  |[g`
	ANSELA	    = 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTA	    = 0b00000000;		//	o̓f[^ݒ(SĂO)
	TRISA	    = 0b00001011;		//	o͕ݒ(RA0,1,3:InputARA2,4,5:Output)
	WPUA	    = 0b00001011;		//	vAbvݒ(RA0,1,3:Pullup)


//				    76543210		//  |[gb
	ANSELC	    = 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTC	    = 0b00000000;		//	o̓f[^ݒ(SĂO)
	TRISC	    = 0b00000000;		//	o͕ݒ(Sďo)
	WPUC	    = 0b00000000;		//	vAbvݒ(SăvAbv)

	__delay_ms(50);					//	TOҋ@;
	eep_read_write(NUM_ADR, &target_number, 0);		// EEPROM Read
	if(9 < target_number){							// ͈͊OisȒlj
		target_number = 0;
		eep_read_write(NUM_ADR, &target_number, 1);	// EEPROM Write
	}

	eep_read_write(CHR_BPS, &bps_character, 0);			// EEPROM Read ʐMaor
	if((bps_character < 0x0a)||(0x0d < bps_character)){	// ͈͊OisȒlj
		bps_character = 0x0d;
		eep_read_write(CHR_BPS, &bps_character, 1);		// EEPROM Write
	}

	for(i=0;i<10;i++){
		PORTA ^= 0x24;				//  LED ON or OFF
		j = RA0;
		__delay_ms(500);			//	TOOҋ@;
		if(j == RA0){
			if(j == 0){				// SET SW:ON
				setpro();			// ݒ菈
			}
		}
	}

	i = 0;
	j = 0;
	h = 0;


	for(i=0;i<12;i++){
		recieved_data[i] = 0;							// VAŎ󂯂f[^NA
	}
	uart_init();										// UART ݒ

	out_7seg_data = 0;									// PUiVZOf[^ɕϊ
	timer0_init();										// Timer0 ݒ
	TMR0IE = 1;											// slqO̊݉
	GIE = 1;											// SĂ̊݉

	wait_ms_count_a = 500;
	wait_ms_count_b = 0;

	while(1){
		if(uart_rx_one(&uc) == 1){							// ML
			uart_tx_one(uc);								// GR[obN
			wait_ms_count_b = 2000;
			if((uc == '.')&&((recieved_data[0] & 0x80) == 0)&&(recieved_data[0] != '.')){	// hbg̎ňOhbgŖ
				recieved_data[0] |= 0x80;					// Õf[^Ɉ
			}else{
				for(i=10; 0 < i; i--){
					recieved_data[i] = recieved_data[i-1];	// VAŎ󂯂f[^
				}
				recieved_data[0] = (uc & 0x7f);				// VAŎ󂯂f[^𒙂߂
			}
			if(uc == 0x0d){
				h = recieved_data[target_number+1];			// VAŎ󂯂f[^̎wԍǂ
				out_7seg_data = chg_7seg_data(h & 0x7f);	// ASCII --> 7seg Data
				if((h & 0x80) != 0){						// hbgL鎞
					out_7seg_data |= 0x80;					// DPseg ǉ
				}
				for(i=0;i<12;i++){
					recieved_data[i] = 0;					// VAŎ󂯂f[^NA
				}
			}
		}

		if(wait_ms_count_led != 0){
			RA2 = 1;									// LED ON
		}else{
			RA2 = 0;									// LED OFF
		}
	}
}
